    program

    ! Some Tips
    !   To test Easter.C do not name your Clarion module the same
    !   When I had Easter.CLW and Easter.PRJ I could not get it to compile
    !   I think the Easter.OBJ file from the .CLW was overwriting the .C files OBJ
    !
    ! See the .CPP and .H file for how they were made
    !

    map
    end
    map
        MODULE('easter') !('Easter.C')
           ! void easter_date( const long year, int *month, int *day)
           !Note that this does not use the leading underscore int the NAME()
           !because easter.h uses extern "Pascal"
           !this has nothing to do with the PASCAL calling convention
       !   easter_date( signed year, *signed out_mon, *signed out_day),NAME('easter_date')   !Pascal extern
           easter_date( signed year, *signed out_mon, *signed out_day),NAME('_easter_date@FlPiPi')   !C++ extern

           !a prototype that doesnot need a NAME()
           !extern "C++" void easter_date( const long year, short *month, short *day);       // Use C++ and put the mangled name in the
           easter_date( signed year, <*short out_mon>, <*short out_day>)
                    !this above does not need ,NAME('easter_date@FlPiPi')
                    !becuase the C++ mangling matches
                    !I had to add
        END
    end

eYear   signed

!eMon    signed
!eDay    signed

eMon    short          !use the
eDay    short

eDates  string(256)

    code
    eYear = year(today())
    loop 10 times
         easter_date(eYear,eMon,eDay)
         eDates = clip(eDates) & '|<9>' & eMon &'/'& eDay &'/'& eYear
         eYear += 1
    end

    Message('Easter for the next 10 years will be ' & clip(eDates),'Easter Date')





!Artcle code was a little prettier and simpler
!  map
!    module('easter.c')
!      easter_date( long year, <*short month>, <*short day>)
!    end
!  end
!
!eYear   long
!eMon    short
!eDay    short
!
!eDates  string(256)
!
!    code
!    eYear = year(today())
!    easter_date(eYear,eMon,eDay)
!    message('Easter: ' & eMon &'/'& eDay &'/'& eYear)
