#Template(Qprocess,'Using the QueueProcessManagerClass'),Family('ABC','CW20')
#Extension(QProcess,'Make use of the QueueManagerProcessClass'),Procedure
#Prepare
  #Call(%ReadABCFiles(ABC))
  #CALL(%SetClassDefaults(ABC), 'QueueProcessManagerClass', 'ThisProcess','QueueProcessManagerClass')
#EndPrepare
 #TAB('Template prompts')
 #Prompt('Label of queue',Expr),%Queue,REQ
 #Prompt('Records pr cycle',Expr),%RecordsPerCycle,Default(25)
 #Prompt('Timer setting',Expr),%Timer,Default(1)
 #Prompt('Message on no records',Check),%NoRecords
 #Boxed('Message text'),Where(%NoRecords)
   #Prompt('Message',Expr),%MsgText,REQ,Default('There are no records to process')
   #Prompt('Caption',Expr),%MsgCaption,REQ,Default('No action taken')
 #EndBoxed
 #Prompt('Completed text',Expr),%Completed,Default('Completed'),REQ
 #Prompt('Text control',Control),%ProgressPctText,Default('?Progress:PctText'),REQ
 #Prompt('Progress control',Control),%ProgressThermometer,Default('?Progress:Thermometer'),REQ
 #Prompt('Cancel button',Control),%ProgressCancel,Default('?Progress:Cancel'),REQ
 #Prompt('Pause button',Control),%PauseButton
 #Boxed(''),Where(%PauseButton)
 #Prompt('Start paused',Check),%StartPaused
 #Prompt('Pause text',Expr),%PauseText,Default('Pause'),REQ
 #Prompt('Run text',Expr),%RunText,Default('Run'),REQ
 #EndBoxed
 #Prompt('Do not close window',Check),%NoCloseWindow
 #EndTAB
 #TAB('Classes')
  #Insert(%OOPPrompts(ABC))
  #With(%ClassItem,'QueueProcessManagerClass')
    #Insert(%ClassPrompts(ABC))
  #EndWith
 #EndTAB
#LOCALDATA
Progress:Thermometer BYTE
#ENDLOCALDATA
#!------------------------------------------------------------------------
#!Below we tell the template chain that we are going to make use of the classes
#AtSTart
  #Call(%ReadABCFiles(ABC))
  #CALL(%SetClassDefaults(ABC), 'QueueProcessManagerClass', 'ThisProcess','QueueProcessManagerClass')
#Endat
#!obsolete code in 6
#!AT(%GatherObjects)
#!Really not necessary in Clarion6
#!CALL(%AddObjectList(ABC), 'QueueProcessManagerClass', 'QueueProcessManagerClass')
#!Endat
#!-----------------------------------------------------------------------------------
#!Including the class header file
#!AT(%ModuleDataSection)
#!Not necessary in 6.0
#!Include('Qprocess.inc'),Once #<!we make use of these classes
#!EndAT
#!--------------------------------------------------------------------
#AT(%LocalDataClasses)
#!Use The queue processmanager class to read a queue
#INSERT(%GenerateClass(ABC),'QueueProcessManagerClass')
#EndAT
#!------------------------------------------------------------------------------------
#!Class definition for Queueprocessmanagerclass
 #AT(%LocalProcedures)
  #CALL(%GenerateVirtuals(ABC),'QueueProcessManagerClass','Local Objects|Abc Objects|'&%ThisObjectName,'%ProcessVirtuals(ABC)',%False)
#ENDAT
#AT(%ProcessManagerMethodCodeSection),PRIORITY(5000),DESCRIPTION('Parent Call')
  #CALL(%GenerateParentCall(ABC))
#ENDAT
#!-------------------------------------------------------------------------------------
#At(%ProcessManagerMethodCodeSection,'TakeNoRecords'),Priority(7500),Where(%NoRecords)
  Message(%(%StripPling(%MsgText)),%(%StripPling(%MsgCaption)))
#EndAT
#!----------------
 #At(%AfterOpeningWindow)
 !Process class initialization code
   %ThisObjectName.Init(%queue) #<!use this queue
   %ThisObjectName.SetControls(%(%StripPling(%Completed)),%ProgressThermometer,%ProgressCancel,%ProgressPctText) #<!no pause
   %ThisObjectName.SetProgressLimits(%Timer,%RecordsPerCycle) #<!Set progress behaviour
   %ThisObjectName.Open()  #<!set timer and stuff
   %ThisObjectName.Run()   #<!RUN Immediately
   #If(%StartPaused And %PauseButton)
   %ThisObjectName.SetPause() #<!Start paused
   %PauseButton{Prop:Text}=%(%StripPling(%RunText))
   #EndIf
   #If(%NoCloseWindow)
   %ThisObjectName.SetCloseWindow(False)
   #EndIf
#EndAT
#AT(%AcceptLoopAfterEventHandling)
   ReturnValue = %ThisObjectName.TakeEvent()
#EndAT
#At(%ControlEventHandling,%PauseButton,'Accepted'),Priority(2500),Where(%PauseButton)
        %ThisObjectName.SetPause()    #<!toggle on/off
        If %ThisObjectName.IsPaused() #<!is paused
           ?{Prop:Text}=%(%StripPling(%RunText))   #<!change text
           %ThisObjectName.TakePaused() #<!in case some particular handling
        Else                      #<!soon to be paused
           ?{Prop:Text}=%(%StripPling(%PauseText))     #<!Change text  
        End
        Display()
        Cycle                     #<!we handle everything

#EndAT
#!Groups
#GROUP(%StripPling,%Incoming)
  #IF(SUB(%Incoming,1,1)='!')
    #RETURN(SUB(%Incoming,2))
  #ELSIF(SUB(%Incoming,1,1)='=')
    #RETURN('EVALUATE(' & %StripPling(SUB(%Incoming, 2)) & ')')
  #ELSIF(UPPER(%Incoming)='TRUE' OR UPPER(%Incoming)='FALSE')
    #RETURN(%Incoming)
  #ELSIF(UPPER(%Incoming)='''TRUE''' OR UPPER(%Incoming)='''FALSE''')
    #RETURN(%Incoming)
  #ELSE
    #RETURN( '''' & QUOTE(%Incoming) & '''' )
  #ENDIF

#!------------------------------------------------------------------------
#!if you should make a multi template of this, you will need the below group
#!-sample of virtuals
#GROUP(%QProcessVirtuals,%TreeText,%DataText,%CodeText)
#EMBED(%QProcessMethodDataSection,'QProcess Method Data Section'),%ActiveTemplateInstance,%pClassMethod,%pClassMethodPrototype,LABEL,DATA,PREPARE(,,%FixClassName(%FixBaseClassToUse('QueueProcessManagerClass'))),TREE(%TreeText & %DataText)
  #?CODE
  #EMBED(%QProcessMethodCodeSection,'QProcess Method Executable Code Section'),%ActiveTemplateInstance,%pClassMethod,%pClassMethodPrototype,PREPARE(,,%FixClassName(%FixBaseClassToUse('QueueProcessManagerClass'))),TREE(%TreeText & %CodeText)
