    program

    !Adding some C code to your Clarion App
    !1. I downloaded and saved the RC4.h and RC4.C files
    !2. I modified the .h file to wrap the functions in  extern "C" { };
    !        or you'll get a linker due to the name mangling
    !        Example
    !               extern "C" {
    !                    void rc4_setup( struct rc4_state *s, unsigned char *key,  int length );
    !                          };
    !3. Prototyped the C functions in Clarion and made the NAME('_xxx') start with an underscore the Extern C standard
    !4. Added RAW since I would be passing strings
    !5. Since the C code is being compiled by Clarion Pascal is not needed ?
    !6. I prototyped other structures/equates in Clarion needed to pass to the C functions
    !7. I added the .C source moudle to my project

    !The biggest part was trying to figure out how to use these two functions
    !3 damn functions, here's what I figured out
    !see example below

    !Pages of interest
    !   http://www.cr0.net:8040/code/crypto/            Where the code came from
    !   http://www.l3.u-net.com/articles/art3.htm       Using C in Clarion

    include 'aes_h_inc.inc'

EnKey   STRING('supercalifragilisticexpeealidoshish')
ctx     LIKE(aes_context)
ret     signed

encrypt_16In     STRING(16)
encrypt_16Out    STRING(16)
decrypt_16In     STRING(16)
decrypt_16Out    STRING(16)

    CODE
    !Create the AES Context
    ret = aes_set_key(ctx, EnKey, SetKeyBits_High )
    if ret<>0 then Message('aes_set_key failed ret=' & ret).

    encrypt_16In='the clarion call'
    aes_encrypt( ctx, encrypt_16In, encrypt_16Out )

    Message('In Data: ' & encrypt_16In & '||Out Data: ' & encrypt_16Out, 'aes_encrypt')

    decrypt_16In = encrypt_16Out
    aes_decrypt( ctx, decrypt_16In, decrypt_16Out )

    Message('In Data: ' & decrypt_16In & '||Out Data: ' & decrypt_16Out & '||' &   |
             choose(decrypt_16Out=encrypt_16In,'PASSED!','FAILED!!!'), 'aes_decrypt')


