    program

    pragma('module(smart_link=>off)')
    map
        MODULE('CFun.C')
            p_func2(signed i),signed,name('P_FUNC2') !    extern "Pascal" int p_func(int i);
            m_func3(signed i),signed,name('m_func3') !    extern "Modula2" int m_func3(int i);
            m_func4(signed i),signed,name('Carl$m_func4') !    extern "Modula2.Carl" int m_func4(int i);
            cpp_func5(signed i),signed,name('_cpp_func5@Fi') !    extern "C++" int cpp_func5(int i);
            cpp_func6(signed i),signed                       !    #pragma name(prefix=>""))    extern "C++" long cpp_func6(long i);
                    !      Unresolved External CPP_FUNC6@Fl in MangTest.obj
                    !                          cpp_func6@Fi
        END

IAmNotCalled    procedure(long L, signed S, unsigned U)
    end

a   signed
    code
    IAmNotCalled(1,2,3)
    Message('2 * 6 = ' & cpp_func6(2) )



IAmNotCalled    procedure(long L, signed S, unsigned U)
    code
    return


!Advanced Programming Guide, Multi Language Programming, Resolving Naming Conventions
!says:
!Use the "Pascal" external linkage specification for your C++ interface functions. This
!eliminates the need to use the Clarion NAME attribute on the prototype.
!
!That is not correct. Pascal naming convention simply means no underscore prefixed and upper case the name, plus parameter mangle is not added.
!So with extern "Pascal" you still need a NAME().
!If you use extern "C++" and prefix=>"" and the right parms you can deal with mangling better, but INT type is a problem
!
!            p_func2(signed i),signed,name('P_FUNC2') !    extern "Pascal" int p_func(int i);
!            m_func3(signed i),signed,name('m_func3') !    extern "Modula2" int m_func3(int i);
!            m_func4(signed i),signed,name('Carl$m_func4') !    extern "Modula2.Carl" int m_func4(int i);
!            cpp_func5(signed i),signed,name('_cpp_func5@Fi') !    extern "C++" int cpp_func5(int i);
!            cpp_func6(signed i),signed                       !    #pragma name(prefix=>""))    extern "C++" long cpp_func6(long i);
