!#ifndef _SHA1_H
!#define _SHA1_H

!#ifndef uint8
!#define uint8  unsigned char
!#endif

!#ifndef uint32
!#define uint32 unsigned long int
!#endif

sha1_context    GROUP,TYPE  !typedef struct {
total   SIGNED,DIM(2)       !    uint32 total[2];
state   SIGNED,DIM(5)       !    uint32 state[5];
buffer  STRING(64)          !    uint8 buffer[64];
                END         !       } sha1_context;

Sha_Digest20    GROUP,TYPE
Digest              STRING(20)
DigestArray         BYTE,DIM(20),OVER(Digest)
                END

  MAP
    MODULE('SHA1')
      sha1_starts(*sha1_context ctx ),RAW,NAME('_sha1_starts')
      sha1_update(*sha1_context ctx, *STRING input, SIGNED length ),RAW,NAME('_sha1_update')
      sha1_finish(*sha1_context ctx, *Sha_Digest20 digest20 ),RAW,NAME('_sha1_finish')
    END
  END

CompileC CLASS,TYPE,LINK('sha1.c',_ABCLinkMode_),DLL(_ABCDllMode_)
         END
